package it.unibo.tw0708.spring.main;

import it.unibo.tw0708.beans.compactDiscs.ICompactDiscsManager;

import org.apache.log4j.Logger;
import org.springframework.beans.factory.BeanFactory;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class MethodInjectionLoaderMainClass {

	public static void main(String[] args)
	throws Exception {
		
		// starts up the application context
		BeanFactory applicationContext = new ClassPathXmlApplicationContext("appMethodInjectionApplicationContext.xml");

		// get the logger to print out something interesting...
		Logger rootLogger = (Logger) applicationContext.getBean("logger");
		
		// let's get the beans we are interested in
		ICompactDiscsManager compactDiscsManager = (ICompactDiscsManager) applicationContext.getBean("compactDiscsManager");
		compactDiscsManager.getOwner().setName("pisi");

		// now let's play with run-time method replacement via method injection
		int collectionSize = compactDiscsManager.getCollectionSize();
		String element_s = ( collectionSize == 1 ) ? "element" : "elements";
		rootLogger.info(
				"\ncompactDiscsManager has been tweaked with method injection and currently shows a double-sized CD collection of " + 
				collectionSize + " " + element_s + " (correct is: 4)\n");
	}

}
