package it.unibo.tw0708.dao.tx.jpa;

import it.unibo.tw0708.dao.CompactDiscDAO;
import it.unibo.tw0708.dao.CompactDiscTO;

import java.util.ArrayList;
import java.util.List;

import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;

import org.apache.log4j.Logger;

public class EntityManagerTxCompactDiscDAO 
implements CompactDiscDAO {

	@PersistenceContext
	private EntityManager em;

	private Logger logger;
	public void setLogger(Logger logger) { this.logger = logger; }

	// -----------------------------------------
	
	public List<CompactDiscTO> getCompactDiscs(String username) {
		Query query = em.createQuery("from CompactDiscEntity as cd where cd.owner = :username");
		query.setParameter("username", username);
		// returning detached objects
		List<CompactDiscTO> result = new ArrayList<CompactDiscTO>();
		List queryResultList = query.getResultList();
		if ( queryResultList == null ) 
			return result;
		for ( Object queryResultObject : queryResultList )
			result.add( ((CompactDiscEntity)queryResultObject).toTransferObject() );
		return result;
	}
	
	public void addCompactDiscs(CompactDiscTO compactDiscTO) {
		if ( compactDiscTO.getId() == 0 )
			em.persist(new CompactDiscEntity(compactDiscTO));
		else
			em.merge(new CompactDiscEntity(compactDiscTO));
	}

	public void removeCompactDiscs(CompactDiscTO compactDiscTO) {
		CompactDiscEntity persistentCompactDisc = em.find(CompactDiscEntity.class, compactDiscTO.getId());
		if ( persistentCompactDisc != null ) {
			em.remove(persistentCompactDisc);
		}
		else
			logger.warn("Could not find compact disc entity with id = " + compactDiscTO.getId());
	}

}
