package it.unibo.tw0708.spring.main;

import java.util.Collection;

import it.unibo.tw0708.dao.CompactDiscDAO;
import it.unibo.tw0708.dao.CompactDiscTO;
import it.unibo.tw0708.dao.DAOFactory;

import org.apache.log4j.Logger;
import org.springframework.context.ApplicationContext;
import org.springframework.context.support.ClassPathXmlApplicationContext;

public class UnsupportedOperationMain {

	public static void main(String[] args) {
	    ApplicationContext applicationContext = new ClassPathXmlApplicationContext("dataAccessConfig-hsqldb-unsupportedOperation.xml");//, TxMain.class);
	    // --------------------------------
		Logger rootLogger = (Logger) applicationContext.getBean("logger");
	    // --------------------------------
	    CompactDiscDAO compactDiscDAO = ( (DAOFactory) applicationContext.getBean("daoFactory") ).getCompactDiscDAO();
	    compactDiscDAO.addCompactDiscs(new CompactDiscTO("pisi","Queen","Greatest Hits"));
	    compactDiscDAO.addCompactDiscs(new CompactDiscTO("pisi","Queen","Greatest Hits II"));
	    compactDiscDAO.addCompactDiscs(new CompactDiscTO("pisi","Queen+","Greatest Hits III"));
	    // ---------------------------------
	    Collection<CompactDiscTO> compactDiscsCollection = compactDiscDAO.getCompactDiscs("pisi");
	    if ( compactDiscsCollection != null && compactDiscsCollection.size() > 0 )
	    	for ( CompactDiscTO compactDisc : compactDiscsCollection )
	    		rootLogger.info("user 'pisi' owns " + compactDisc.toString() );
	}

}
