package it.unibo.tw0708.aspects;

import it.unibo.tw0708.beans.compactDiscs.CompactDiscsManager;
import it.unibo.tw0708.beans.user.UserManager;
import it.unibo.tw0708.dao.DAOFactory;

import org.apache.log4j.Logger;
import org.aspectj.lang.JoinPoint;

public class CompactDiscsLoader {

	private Logger logger;
	public void setLogger(Logger logger) { this.logger = logger; }

	// ------------------------------------------------------

	private UserManager owner;
	public void setOwner(UserManager owner) { this.owner = owner; }

	private DAOFactory factory;
	public void setFactory(DAOFactory factory) { this.factory = factory; }
	
	// ------------------------------------------------------

	public void loadCompactDiscs(JoinPoint joinpoint) {
		CompactDiscsManager compactDiscsManager = (CompactDiscsManager) joinpoint.getTarget();
		logger.warn("Retrieving compact disc collection via DAO");
		compactDiscsManager.setCompactDiscs(
			factory.getCompactDiscDAO().getCompactDiscs(
				owner.getName()
			)
		);
	}

}
